org.apache.tomcat.util.net.jsse

## Class JSSEUtil

- java.lang.Object
- - org.apache.tomcat.util.net.SSLUtilBase
  - - org.apache.tomcat.util.net.jsse.JSSEUtil

- All Implemented Interfaces:
    SSLUtil

      public class JSSEUtil
      extends SSLUtilBase

  SSLUtil implementation for JSSE.
  Author:
    Harish Prabandham, Costin Manolache, Stefan Freyr Stefansson, EKR, Jan Luehe

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tomcat.util.net.SSLUtil

      `SSLUtil.ProtocolInfo`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tomcat.util.net.SSLUtilBase

      `certificate`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JSSEUtil(SSLHostConfigCertificate certificate)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configureSessionContext(SSLSessionContext sslSessionContext)`
    `SSLContext` | `createSSLContext(List<String> negotiableProtocols)`
    `protected Collection<? extends CRL>` | `getCRLs(String crlf)` Load the collection of CRLs.
    `protected Set<String>` | `getImplementedCiphers()`
    `protected Set<String>` | `getImplementedProtocols()`
    `KeyManager[]` | `getKeyManagers()`
    `protected Log` | `getLog()`
    `protected CertPathParameters` | `getParameters(String crlf, KeyStore trustStore, boolean revocationEnabled)` Return the initialization parameters for the TrustManager.
    `TrustManager[]` | `getTrustManagers()`

    - ### Methods inherited from class org.apache.tomcat.util.net.SSLUtilBase

      `getEnabledCiphers, getEnabledProtocols`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JSSEUtil

          public JSSEUtil(SSLHostConfigCertificate certificate)

  - ### Method Detail

    - #### getLog

          protected Log getLog()

      Specified by:
        `getLog` in class `SSLUtilBase`

    - #### getImplementedProtocols

          protected Set<String> getImplementedProtocols()

      Specified by:
        `getImplementedProtocols` in class `SSLUtilBase`

    - #### getImplementedCiphers

          protected Set<String> getImplementedCiphers()

      Specified by:
        `getImplementedCiphers` in class `SSLUtilBase`

    - #### createSSLContext

          public SSLContext createSSLContext(List<String> negotiableProtocols)
                                      throws NoSuchAlgorithmException

      Throws:
        `NoSuchAlgorithmException`

    - #### getKeyManagers

          public KeyManager[] getKeyManagers()
                                      throws Exception

      Throws:
        `Exception`

    - #### getTrustManagers

          public TrustManager[] getTrustManagers()
                                          throws Exception

      Throws:
        `Exception`

    - #### configureSessionContext

          public void configureSessionContext(SSLSessionContext sslSessionContext)

    - #### getParameters

          protected CertPathParameters getParameters(String crlf,
                                         KeyStore trustStore,
                                         boolean revocationEnabled)
                                              throws Exception

      Return the initialization parameters for the TrustManager. Currently, only the default `PKIX` is supported.
      Parameters:
        `crlf` - The path to the CRL file.
        `trustStore` - The configured TrustStore.
        `revocationEnabled` - Should the JSSE provider perform revocation checks? Ignored if `crlf` is non-null. Configuration of revocation checks are expected to be via proprietary JSSE provider methods.
      Returns:
        The parameters including the CRLs and TrustStore.
      Throws:
        `Exception` - An error occurred

    - #### getCRLs

          protected Collection<? extends CRL> getCRLs(String crlf)
                                               throws IOException,
                                                      CRLException,
                                                      CertificateException

      Load the collection of CRLs.
      Parameters:
        `crlf` - The path to the CRL file.
      Returns:
        the CRLs collection
      Throws:
        `IOException` - Error reading CRL file
        `CRLException` - CRL error
        `CertificateException` - Error processing certificate

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.